<?php
/**
 * NowcastObj
 *
 * PHP version 5
 *
 * @category Class
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Weather Source Nowcast API
 *
 * Nowcast weather data for latitude/longitude points, ZIP/Postal Codes, Designated Market Areas, and OnPoint™ points. The Weather Source Nowcast API is built upon the [OnPoint™ Platform](https://weathersource.com/products/onpoint-platform/) which ensures data that is gap-free, homogeneous, and ready for immediate analysis. We offer the highest resolution grid on the market, covering every landmass in the world and up to 200 miles offshore.  An API key is required to authorize requests. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/).
 *
 * OpenAPI spec version: 2.0.0
 * Contact: support@weathersource.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 3.0.19
 */
/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Swagger\Client\Model;

use \ArrayAccess;
use \Swagger\Client\ObjectSerializer;

/**
 * NowcastObj Class Doc Comment
 *
 * @category Class
 * @description A nowcast object.
 * @package  Swagger\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class NowcastObj implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'nowcastObj';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'timestamp' => '\Swagger\Client\Model\Timestamp',
'cld_cvr' => '\Swagger\Client\Model\CldCvr',
'dew_pt' => '\Swagger\Client\Model\DewPt',
'feels_like' => '\Swagger\Client\Model\FeelsLike',
'heat_index' => '\Swagger\Client\Model\HeatIndex',
'msl_pres' => '\Swagger\Client\Model\MslPres',
'precip_flag' => '\Swagger\Client\Model\PrecipFlag',
'precip_intensity' => '\Swagger\Client\Model\PrecipIntensity',
'pres_tend' => '\Swagger\Client\Model\PresTend',
'rad_solar' => '\Swagger\Client\Model\RadSolar',
'rel_hum' => '\Swagger\Client\Model\RelHum',
'sfc_pres' => '\Swagger\Client\Model\SfcPres',
'snowfall_flag' => '\Swagger\Client\Model\SnowfallFlag',
'snowfall_intensity' => '\Swagger\Client\Model\SnowfallIntensity',
'spc_hum' => '\Swagger\Client\Model\SpcHum',
'temp' => '\Swagger\Client\Model\Temp',
'wet_bulb' => '\Swagger\Client\Model\WetBulb',
'wind_chill' => '\Swagger\Client\Model\WindChill',
'wind_dir' => '\Swagger\Client\Model\WindDir',
'wind_dir80m' => '\Swagger\Client\Model\WindDir80m',
'wind_dir100m' => '\Swagger\Client\Model\WindDir100m',
'wind_spd' => '\Swagger\Client\Model\WindSpd',
'wind_spd80m' => '\Swagger\Client\Model\WindSpd80m',
'wind_spd100m' => '\Swagger\Client\Model\WindSpd100m'    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'timestamp' => null,
'cld_cvr' => null,
'dew_pt' => null,
'feels_like' => null,
'heat_index' => null,
'msl_pres' => null,
'precip_flag' => null,
'precip_intensity' => null,
'pres_tend' => null,
'rad_solar' => null,
'rel_hum' => null,
'sfc_pres' => null,
'snowfall_flag' => null,
'snowfall_intensity' => null,
'spc_hum' => null,
'temp' => null,
'wet_bulb' => null,
'wind_chill' => null,
'wind_dir' => null,
'wind_dir80m' => null,
'wind_dir100m' => null,
'wind_spd' => null,
'wind_spd80m' => null,
'wind_spd100m' => null    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'timestamp' => 'timestamp',
'cld_cvr' => 'cldCvr',
'dew_pt' => 'dewPt',
'feels_like' => 'feelsLike',
'heat_index' => 'heatIndex',
'msl_pres' => 'mslPres',
'precip_flag' => 'precipFlag',
'precip_intensity' => 'precipIntensity',
'pres_tend' => 'presTend',
'rad_solar' => 'radSolar',
'rel_hum' => 'relHum',
'sfc_pres' => 'sfcPres',
'snowfall_flag' => 'snowfallFlag',
'snowfall_intensity' => 'snowfallIntensity',
'spc_hum' => 'spcHum',
'temp' => 'temp',
'wet_bulb' => 'wetBulb',
'wind_chill' => 'windChill',
'wind_dir' => 'windDir',
'wind_dir80m' => 'windDir80m',
'wind_dir100m' => 'windDir100m',
'wind_spd' => 'windSpd',
'wind_spd80m' => 'windSpd80m',
'wind_spd100m' => 'windSpd100m'    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'timestamp' => 'setTimestamp',
'cld_cvr' => 'setCldCvr',
'dew_pt' => 'setDewPt',
'feels_like' => 'setFeelsLike',
'heat_index' => 'setHeatIndex',
'msl_pres' => 'setMslPres',
'precip_flag' => 'setPrecipFlag',
'precip_intensity' => 'setPrecipIntensity',
'pres_tend' => 'setPresTend',
'rad_solar' => 'setRadSolar',
'rel_hum' => 'setRelHum',
'sfc_pres' => 'setSfcPres',
'snowfall_flag' => 'setSnowfallFlag',
'snowfall_intensity' => 'setSnowfallIntensity',
'spc_hum' => 'setSpcHum',
'temp' => 'setTemp',
'wet_bulb' => 'setWetBulb',
'wind_chill' => 'setWindChill',
'wind_dir' => 'setWindDir',
'wind_dir80m' => 'setWindDir80m',
'wind_dir100m' => 'setWindDir100m',
'wind_spd' => 'setWindSpd',
'wind_spd80m' => 'setWindSpd80m',
'wind_spd100m' => 'setWindSpd100m'    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'timestamp' => 'getTimestamp',
'cld_cvr' => 'getCldCvr',
'dew_pt' => 'getDewPt',
'feels_like' => 'getFeelsLike',
'heat_index' => 'getHeatIndex',
'msl_pres' => 'getMslPres',
'precip_flag' => 'getPrecipFlag',
'precip_intensity' => 'getPrecipIntensity',
'pres_tend' => 'getPresTend',
'rad_solar' => 'getRadSolar',
'rel_hum' => 'getRelHum',
'sfc_pres' => 'getSfcPres',
'snowfall_flag' => 'getSnowfallFlag',
'snowfall_intensity' => 'getSnowfallIntensity',
'spc_hum' => 'getSpcHum',
'temp' => 'getTemp',
'wet_bulb' => 'getWetBulb',
'wind_chill' => 'getWindChill',
'wind_dir' => 'getWindDir',
'wind_dir80m' => 'getWindDir80m',
'wind_dir100m' => 'getWindDir100m',
'wind_spd' => 'getWindSpd',
'wind_spd80m' => 'getWindSpd80m',
'wind_spd100m' => 'getWindSpd100m'    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['timestamp'] = isset($data['timestamp']) ? $data['timestamp'] : null;
        $this->container['cld_cvr'] = isset($data['cld_cvr']) ? $data['cld_cvr'] : null;
        $this->container['dew_pt'] = isset($data['dew_pt']) ? $data['dew_pt'] : null;
        $this->container['feels_like'] = isset($data['feels_like']) ? $data['feels_like'] : null;
        $this->container['heat_index'] = isset($data['heat_index']) ? $data['heat_index'] : null;
        $this->container['msl_pres'] = isset($data['msl_pres']) ? $data['msl_pres'] : null;
        $this->container['precip_flag'] = isset($data['precip_flag']) ? $data['precip_flag'] : null;
        $this->container['precip_intensity'] = isset($data['precip_intensity']) ? $data['precip_intensity'] : null;
        $this->container['pres_tend'] = isset($data['pres_tend']) ? $data['pres_tend'] : null;
        $this->container['rad_solar'] = isset($data['rad_solar']) ? $data['rad_solar'] : null;
        $this->container['rel_hum'] = isset($data['rel_hum']) ? $data['rel_hum'] : null;
        $this->container['sfc_pres'] = isset($data['sfc_pres']) ? $data['sfc_pres'] : null;
        $this->container['snowfall_flag'] = isset($data['snowfall_flag']) ? $data['snowfall_flag'] : null;
        $this->container['snowfall_intensity'] = isset($data['snowfall_intensity']) ? $data['snowfall_intensity'] : null;
        $this->container['spc_hum'] = isset($data['spc_hum']) ? $data['spc_hum'] : null;
        $this->container['temp'] = isset($data['temp']) ? $data['temp'] : null;
        $this->container['wet_bulb'] = isset($data['wet_bulb']) ? $data['wet_bulb'] : null;
        $this->container['wind_chill'] = isset($data['wind_chill']) ? $data['wind_chill'] : null;
        $this->container['wind_dir'] = isset($data['wind_dir']) ? $data['wind_dir'] : null;
        $this->container['wind_dir80m'] = isset($data['wind_dir80m']) ? $data['wind_dir80m'] : null;
        $this->container['wind_dir100m'] = isset($data['wind_dir100m']) ? $data['wind_dir100m'] : null;
        $this->container['wind_spd'] = isset($data['wind_spd']) ? $data['wind_spd'] : null;
        $this->container['wind_spd80m'] = isset($data['wind_spd80m']) ? $data['wind_spd80m'] : null;
        $this->container['wind_spd100m'] = isset($data['wind_spd100m']) ? $data['wind_spd100m'] : null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['timestamp'] === null) {
            $invalidProperties[] = "'timestamp' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets timestamp
     *
     * @return \Swagger\Client\Model\Timestamp
     */
    public function getTimestamp()
    {
        return $this->container['timestamp'];
    }

    /**
     * Sets timestamp
     *
     * @param \Swagger\Client\Model\Timestamp $timestamp timestamp
     *
     * @return $this
     */
    public function setTimestamp($timestamp)
    {
        $this->container['timestamp'] = $timestamp;

        return $this;
    }

    /**
     * Gets cld_cvr
     *
     * @return \Swagger\Client\Model\CldCvr
     */
    public function getCldCvr()
    {
        return $this->container['cld_cvr'];
    }

    /**
     * Sets cld_cvr
     *
     * @param \Swagger\Client\Model\CldCvr $cld_cvr cld_cvr
     *
     * @return $this
     */
    public function setCldCvr($cld_cvr)
    {
        $this->container['cld_cvr'] = $cld_cvr;

        return $this;
    }

    /**
     * Gets dew_pt
     *
     * @return \Swagger\Client\Model\DewPt
     */
    public function getDewPt()
    {
        return $this->container['dew_pt'];
    }

    /**
     * Sets dew_pt
     *
     * @param \Swagger\Client\Model\DewPt $dew_pt dew_pt
     *
     * @return $this
     */
    public function setDewPt($dew_pt)
    {
        $this->container['dew_pt'] = $dew_pt;

        return $this;
    }

    /**
     * Gets feels_like
     *
     * @return \Swagger\Client\Model\FeelsLike
     */
    public function getFeelsLike()
    {
        return $this->container['feels_like'];
    }

    /**
     * Sets feels_like
     *
     * @param \Swagger\Client\Model\FeelsLike $feels_like feels_like
     *
     * @return $this
     */
    public function setFeelsLike($feels_like)
    {
        $this->container['feels_like'] = $feels_like;

        return $this;
    }

    /**
     * Gets heat_index
     *
     * @return \Swagger\Client\Model\HeatIndex
     */
    public function getHeatIndex()
    {
        return $this->container['heat_index'];
    }

    /**
     * Sets heat_index
     *
     * @param \Swagger\Client\Model\HeatIndex $heat_index heat_index
     *
     * @return $this
     */
    public function setHeatIndex($heat_index)
    {
        $this->container['heat_index'] = $heat_index;

        return $this;
    }

    /**
     * Gets msl_pres
     *
     * @return \Swagger\Client\Model\MslPres
     */
    public function getMslPres()
    {
        return $this->container['msl_pres'];
    }

    /**
     * Sets msl_pres
     *
     * @param \Swagger\Client\Model\MslPres $msl_pres msl_pres
     *
     * @return $this
     */
    public function setMslPres($msl_pres)
    {
        $this->container['msl_pres'] = $msl_pres;

        return $this;
    }

    /**
     * Gets precip_flag
     *
     * @return \Swagger\Client\Model\PrecipFlag
     */
    public function getPrecipFlag()
    {
        return $this->container['precip_flag'];
    }

    /**
     * Sets precip_flag
     *
     * @param \Swagger\Client\Model\PrecipFlag $precip_flag precip_flag
     *
     * @return $this
     */
    public function setPrecipFlag($precip_flag)
    {
        $this->container['precip_flag'] = $precip_flag;

        return $this;
    }

    /**
     * Gets precip_intensity
     *
     * @return \Swagger\Client\Model\PrecipIntensity
     */
    public function getPrecipIntensity()
    {
        return $this->container['precip_intensity'];
    }

    /**
     * Sets precip_intensity
     *
     * @param \Swagger\Client\Model\PrecipIntensity $precip_intensity precip_intensity
     *
     * @return $this
     */
    public function setPrecipIntensity($precip_intensity)
    {
        $this->container['precip_intensity'] = $precip_intensity;

        return $this;
    }

    /**
     * Gets pres_tend
     *
     * @return \Swagger\Client\Model\PresTend
     */
    public function getPresTend()
    {
        return $this->container['pres_tend'];
    }

    /**
     * Sets pres_tend
     *
     * @param \Swagger\Client\Model\PresTend $pres_tend pres_tend
     *
     * @return $this
     */
    public function setPresTend($pres_tend)
    {
        $this->container['pres_tend'] = $pres_tend;

        return $this;
    }

    /**
     * Gets rad_solar
     *
     * @return \Swagger\Client\Model\RadSolar
     */
    public function getRadSolar()
    {
        return $this->container['rad_solar'];
    }

    /**
     * Sets rad_solar
     *
     * @param \Swagger\Client\Model\RadSolar $rad_solar rad_solar
     *
     * @return $this
     */
    public function setRadSolar($rad_solar)
    {
        $this->container['rad_solar'] = $rad_solar;

        return $this;
    }

    /**
     * Gets rel_hum
     *
     * @return \Swagger\Client\Model\RelHum
     */
    public function getRelHum()
    {
        return $this->container['rel_hum'];
    }

    /**
     * Sets rel_hum
     *
     * @param \Swagger\Client\Model\RelHum $rel_hum rel_hum
     *
     * @return $this
     */
    public function setRelHum($rel_hum)
    {
        $this->container['rel_hum'] = $rel_hum;

        return $this;
    }

    /**
     * Gets sfc_pres
     *
     * @return \Swagger\Client\Model\SfcPres
     */
    public function getSfcPres()
    {
        return $this->container['sfc_pres'];
    }

    /**
     * Sets sfc_pres
     *
     * @param \Swagger\Client\Model\SfcPres $sfc_pres sfc_pres
     *
     * @return $this
     */
    public function setSfcPres($sfc_pres)
    {
        $this->container['sfc_pres'] = $sfc_pres;

        return $this;
    }

    /**
     * Gets snowfall_flag
     *
     * @return \Swagger\Client\Model\SnowfallFlag
     */
    public function getSnowfallFlag()
    {
        return $this->container['snowfall_flag'];
    }

    /**
     * Sets snowfall_flag
     *
     * @param \Swagger\Client\Model\SnowfallFlag $snowfall_flag snowfall_flag
     *
     * @return $this
     */
    public function setSnowfallFlag($snowfall_flag)
    {
        $this->container['snowfall_flag'] = $snowfall_flag;

        return $this;
    }

    /**
     * Gets snowfall_intensity
     *
     * @return \Swagger\Client\Model\SnowfallIntensity
     */
    public function getSnowfallIntensity()
    {
        return $this->container['snowfall_intensity'];
    }

    /**
     * Sets snowfall_intensity
     *
     * @param \Swagger\Client\Model\SnowfallIntensity $snowfall_intensity snowfall_intensity
     *
     * @return $this
     */
    public function setSnowfallIntensity($snowfall_intensity)
    {
        $this->container['snowfall_intensity'] = $snowfall_intensity;

        return $this;
    }

    /**
     * Gets spc_hum
     *
     * @return \Swagger\Client\Model\SpcHum
     */
    public function getSpcHum()
    {
        return $this->container['spc_hum'];
    }

    /**
     * Sets spc_hum
     *
     * @param \Swagger\Client\Model\SpcHum $spc_hum spc_hum
     *
     * @return $this
     */
    public function setSpcHum($spc_hum)
    {
        $this->container['spc_hum'] = $spc_hum;

        return $this;
    }

    /**
     * Gets temp
     *
     * @return \Swagger\Client\Model\Temp
     */
    public function getTemp()
    {
        return $this->container['temp'];
    }

    /**
     * Sets temp
     *
     * @param \Swagger\Client\Model\Temp $temp temp
     *
     * @return $this
     */
    public function setTemp($temp)
    {
        $this->container['temp'] = $temp;

        return $this;
    }

    /**
     * Gets wet_bulb
     *
     * @return \Swagger\Client\Model\WetBulb
     */
    public function getWetBulb()
    {
        return $this->container['wet_bulb'];
    }

    /**
     * Sets wet_bulb
     *
     * @param \Swagger\Client\Model\WetBulb $wet_bulb wet_bulb
     *
     * @return $this
     */
    public function setWetBulb($wet_bulb)
    {
        $this->container['wet_bulb'] = $wet_bulb;

        return $this;
    }

    /**
     * Gets wind_chill
     *
     * @return \Swagger\Client\Model\WindChill
     */
    public function getWindChill()
    {
        return $this->container['wind_chill'];
    }

    /**
     * Sets wind_chill
     *
     * @param \Swagger\Client\Model\WindChill $wind_chill wind_chill
     *
     * @return $this
     */
    public function setWindChill($wind_chill)
    {
        $this->container['wind_chill'] = $wind_chill;

        return $this;
    }

    /**
     * Gets wind_dir
     *
     * @return \Swagger\Client\Model\WindDir
     */
    public function getWindDir()
    {
        return $this->container['wind_dir'];
    }

    /**
     * Sets wind_dir
     *
     * @param \Swagger\Client\Model\WindDir $wind_dir wind_dir
     *
     * @return $this
     */
    public function setWindDir($wind_dir)
    {
        $this->container['wind_dir'] = $wind_dir;

        return $this;
    }

    /**
     * Gets wind_dir80m
     *
     * @return \Swagger\Client\Model\WindDir80m
     */
    public function getWindDir80m()
    {
        return $this->container['wind_dir80m'];
    }

    /**
     * Sets wind_dir80m
     *
     * @param \Swagger\Client\Model\WindDir80m $wind_dir80m wind_dir80m
     *
     * @return $this
     */
    public function setWindDir80m($wind_dir80m)
    {
        $this->container['wind_dir80m'] = $wind_dir80m;

        return $this;
    }

    /**
     * Gets wind_dir100m
     *
     * @return \Swagger\Client\Model\WindDir100m
     */
    public function getWindDir100m()
    {
        return $this->container['wind_dir100m'];
    }

    /**
     * Sets wind_dir100m
     *
     * @param \Swagger\Client\Model\WindDir100m $wind_dir100m wind_dir100m
     *
     * @return $this
     */
    public function setWindDir100m($wind_dir100m)
    {
        $this->container['wind_dir100m'] = $wind_dir100m;

        return $this;
    }

    /**
     * Gets wind_spd
     *
     * @return \Swagger\Client\Model\WindSpd
     */
    public function getWindSpd()
    {
        return $this->container['wind_spd'];
    }

    /**
     * Sets wind_spd
     *
     * @param \Swagger\Client\Model\WindSpd $wind_spd wind_spd
     *
     * @return $this
     */
    public function setWindSpd($wind_spd)
    {
        $this->container['wind_spd'] = $wind_spd;

        return $this;
    }

    /**
     * Gets wind_spd80m
     *
     * @return \Swagger\Client\Model\WindSpd80m
     */
    public function getWindSpd80m()
    {
        return $this->container['wind_spd80m'];
    }

    /**
     * Sets wind_spd80m
     *
     * @param \Swagger\Client\Model\WindSpd80m $wind_spd80m wind_spd80m
     *
     * @return $this
     */
    public function setWindSpd80m($wind_spd80m)
    {
        $this->container['wind_spd80m'] = $wind_spd80m;

        return $this;
    }

    /**
     * Gets wind_spd100m
     *
     * @return \Swagger\Client\Model\WindSpd100m
     */
    public function getWindSpd100m()
    {
        return $this->container['wind_spd100m'];
    }

    /**
     * Sets wind_spd100m
     *
     * @param \Swagger\Client\Model\WindSpd100m $wind_spd100m wind_spd100m
     *
     * @return $this
     */
    public function setWindSpd100m($wind_spd100m)
    {
        $this->container['wind_spd100m'] = $wind_spd100m;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}
